#         Script : Zipcodes v1.00 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2001 Radical Computer Systems
#
#       Testing
#      Platforms : Linux 2.2.16
#                  Eggdrop v1.6.2
#            And : SunOS 5.8
#                  Eggdrop v1.5.4
#
#    Description : Zipcodes lets you search a zipcode and state abbr. database.
#
#        History : 05/03/2001 - First Release
#
#
#   Future Plans : Update the zip codes database.
#
# Author Contact :     Email - DProper@bigfoot.com
#                  Home Page - http://home.earthlink.net/~daproper
#                        IRC - Nick: DrN  UnderNet/DALnet
#
# Chaotix.Net is currentlly offline. Should return no later then Jan 1st, 2002
#
#   Radical Computer Systems - http://www.chaotix.net/rcs/
# To subscribe to the RCS mailing list: mail majordomo@chaotix.net and in
#  BODY of message, type  subscribe rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
# 
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
# 
# If you have a "too cool" modification, send it to me and it'll be
# included in the official release. (With your credit)
#
# Commands Added:
#  Where     F CMD       F CMD         F CMD        F CMD
#  -------   - --------- - ----------- - ---------- - --------- - -------
#  Public:   - !zip      - !zipcode    - !state
#     MSG:   - zipcode   - state
#     DCC:   - N/A
#
# Public Matching: N/A
#

#\
# |##### NOTE: Anything on the Chaotix.Net domain is currently offline
# |#####       until we move. (Wife's in college, taking all our money)
# |#####       Email me at dproper@bigfoot.com if you want to help.
#/

set zipver "v1.00.00"
set cmdchar_ "!"
set zipmaxsearch 5

set zip_zipcodes "/home/eggdrop/scripts/rcs/zipcodes.txt"
set zip_states "/home/eggdrop/scripts/rcs/states.txt"

proc cmdchar { } {
global cmdchar_
return $cmdchar_
}

bind pub - [cmdchar]zipcode pub_zipcode
proc pub_zipcode {nick uhost handle chan args} {
  global prefix totfound
set args [lindex $args 0]

if {$args == ""} {puthelp "NOTICE $nick :Syntax: [cmdchar]zipcode <search string>"
                  return 0}

dozipcodesearch Z $nick $args
}


proc msg_zipsearch {nick uhost handle args} {
  global prefix botnick totfound

if {$args == ""} {puthelp "NOTICE $nick :Syntax: zipcode <search string>"
                  return 0}

dozipcodesearch Z $nick $args
}

bind pub - [cmdchar]state pub_state
proc pub_state {nick uhost handle chan args} {
  global prefix totfound
set args [lindex $args 0]

if {$args == ""} {puthelp "NOTICE $nick :Syntax: [cmdchar]state <search string>"
                  return 0}

dozipcodesearch A $nick $args
}


proc msg_statesearch {nick uhost handle args} {
  global prefix botnick totfound

if {$args == ""} {puthelp "NOTICE $nick :Syntax: state <search string>"
                  return 0}

dozipcodesearch A $nick $args
}

bind msg - state msg_statesearch

proc dozipcodesearch {flag nick data} {
global zipver zipmaxsearch zip_zipcodes zip_states
if {$flag == "A"} {putserv "NOTICE $nick :State Abbreviation Search $zipver by DrN"
                  } else {putserv "NOTICE $nick :Zipcode Search $zipver by DrN"}
  putserv "NOTICE $nick :Searching Database for \"$data\""
  if {$zipmaxsearch != 0} {putserv "NOTICE $nick :There is a limit of $zipmaxsearch results in effect."}
  set data [string tolower $data]

if {$flag == "Z"} {searchzips $flag $nick $zip_zipcodes $data
               } else {searchzips $flag $nick $zip_states $data
                      }
}

proc searchzips {flag nick database data} {
 global zipmaxsearch
    set in [open $database r]
    set totfound 0

    while {![eof $in]} {
      set line [gets $in]
      if {[string match "*$data*" [string tolower $line]]} {

if {$flag == "Z"} {
        set z_ [string range $line 0 4]
        set s_ [string range $line 5 6]
        set c_ [string range $line 7 end] 
        puthelp "NOTICE $nick : \002Found:\002 $c_, $s_  $z_"
                   } else {
        set a_ [string range $line 0 1]
        set s_ [string range $line 2 end]
        puthelp "NOTICE $nick : \002Found:\002 $a_ = $s_"
                          }
      if {$totfound > $zipmaxsearch} {
                  puthelp "NOTICE $nick :There are over $zipmaxsearch matches. Please norrow your search."
                  close $in
                  return 0
                                     }
        set totfound [expr $totfound + 1]
     }
    }
    close $in
    puthelp "NOTICE $nick :There was a total of $totfound entries matching your query."

}


bind pub - [cmdchar]zip pub_zipinform
proc pub_zipinform {nick uhost handle chan args} {
  global prefix totfound
    puthelp "NOTICE $nick :To search the Zipcodes database: [cmdchar]zipcode keyword"
    puthelp "NOTICE $nick :To search the State Abbreviations database: [cmdchar]state keyword"
  return 1
}

return "Zipcode Search $zipver by David Proper (DrN) -: Loaded :-"
